package tests;

import org.junit.*;

import checkers.util.test.*;

/**
 * JUnit tests for the Checker Framework, using the {@link TestChecker}.
 */
public class FrameworkTest extends CheckerTest {

    public FrameworkTest() {
        super("checkers.util.test.TestChecker", "framework", "-Anomsgtext");
    }

    @Test public void testAssignments()                 { test(true);  }
    @Test public void testAssignmentsGeneric()          { test(true);  }

    @Test public void testMethodOverrides()             { test(true);  }
    @Test public void testMethodOverrideBadParam()      { test(false); }
    @Test public void testMethodOverrideBadReceiver()   { test(false); }
    @Test public void testMethodOverrideBadReturn()     { test(false); }
    @Test public void testDeepOverride()                { test(false); }
    @Test public void testDeepOverrideAbstract()        { test(false); }
    @Test public void testDeepOverrideInterface()       { test(false); }
    @Test public void testDeepOverrideBug()             { test(false);  }

    @Test public void testGenericAlias()                { test(true);  }
    @Test public void testGenericAliasInvalid()         { test(false); }
    @Test public void testGenericAliasInvalidCall()     { test(false); }

    @Test public void testVarargs()                     { test(false); }
    @Test public void testAnnotatedVoidMethod()         { test(true);  }
    @Test public void testNoStaticReceiver()            { test(false); }

    @Test public void testMissingSymbolCrash()          { test(false);  }
    @Test public void testMatrixBug()                   { test(true);  }

    @Test public void testClassAnnotations()            { test(true); }
    @Test public void testSupertypes()                  { test(false); }

    @Test public void testSymbolError()                 { test(true); }

    @Test public void testGetReceiverLoop()             { test(true); }

    @Test public void testArrays()                      { test(false); }
    @Test public void testTypeInference()               { test(false); }

    @Test public void testPrimitiveDotClass()           { test(true); }
    @Test public void testConstructors()                { test(false); }
    @Test public void testOverrideCrash()               { test(true); }
}
